using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Props.Shop.Framework;

namespace Props.Shop.Adafruit.Api
{
    public interface IProductListingManager : IDisposable
    {
        public Task<IDictionary<string, IList<ProductListing>>> ProductListings { get; }
        public void RefreshProductListings();
        public void StartUpdateTimer(int delay = 1000 * 60 * 5, int period = 1000 * 60 * 5);
        public void StopUpdateTimer();

        public Task<ProductListing> GetProductListingFromUrl(string url);
    }
}