using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;

namespace Props.Shop.Framework
{
    public interface IShop : IDisposable
    {
        string ShopName { get; }
        string ShopDescription { get; }
        string ShopModuleAuthor { get; }

        public IAsyncEnumerable<ProductListing> Search(string query, Filters filters);

        public Task<ProductListing> GetProductListingFromUrl(string url);

        void Initialize(string workspaceDir, ILoggerFactory loggerFactory);
        public SupportedFeatures SupportedFeatures { get; }
    }
}